/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DataBase;

import Objects.CAuthor;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author vasena
 */
public class DBAuthor {

    DBConnection dbc;

    public DBAuthor(DBConnection dbc) {
        this.dbc = dbc;
    }

    public List LoadList() throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        List<CAuthor> AuthorList = new LinkedList<CAuthor>();
        String query = "Select * from Author";
        ResultSet rs = dbc.getStatement().executeQuery(query);
        CAuthor Author;
        while (rs.next()) {
            int ID = rs.getInt("ID_AUTHOR");
            String Name = rs.getString("NAME");
            String Surname = rs.getString("SURNAME");
            Date Year = rs.getDate("YEAR");
            Author = new CAuthor(ID, Name, Surname, Year);
            AuthorList.add(Author);
        }
        rs.close();
        return AuthorList;
    }

    public CAuthor getAuthor(int ID) throws SQLException {
        List<CAuthor> AuthorList = this.LoadList();
        CAuthor Result = null;
        for (CAuthor Author : AuthorList) {
            if (Author.getID() == ID) {
                Result = Author;
                break;
            }
        }
        return Result;
    }

    public List searchAuthor(String Name, String Surname) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        List<CAuthor> AuthorList = new LinkedList<CAuthor>();
        String query = "Select * from Author where ";
        if (Name!=null){
          query+="Name='"+Name+"'";
        }
        if (Name!=null && Surname!=null){
          query+=" and ";
        }
        if (Surname!=null){
          query+="Surname='"+Surname+"'";
        }
        ResultSet rs = dbc.getStatement().executeQuery(query);
        CAuthor Author;
        while (rs.next()) {
            int ID = rs.getInt("ID_AUTHOR");
            Name = rs.getString("NAME");
            Surname = rs.getString("SURNAME");
            Date Year = rs.getDate("YEAR");
            Author = new CAuthor(ID, Name, Surname, Year);
            AuthorList.add(Author);
        }
        rs.close();
        return AuthorList;
    }

    public void addAuthor(String Name, String Surname, Date Year) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        PreparedStatement ps = dbc.getConnection().prepareStatement("Insert into Author values(author_.nextval,?,?,?)");
        ps.setString(1, Name);
        ps.setString(2, Surname);
        ps.setDate(3, Year);
        ps.execute();
        ps.close();
    }

    public void updateAuthor(int ID, String Name, String Surname, Date Year) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        PreparedStatement ps = dbc.getConnection().prepareStatement("Update Author set Name=?, Surname=?, Year=? where ID_Author=?");
        ps.setString(1, Name);
        ps.setString(2, Surname);
        ps.setDate(3, Year);
        ps.setInt(4, ID);
        ps.execute();
        ps.close();
    }

    public void deleteAuthor(int ID) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        PreparedStatement ps = dbc.getConnection().prepareStatement("Delete from Book_Properties where ID_Book in (select ID_Book from Book where ID_Author=?)");
        ps.setInt(1, ID);
        ps.execute();
        ps.close();
        ps = dbc.getConnection().prepareStatement("Delete from Book where ID_Author=?");
        ps.setInt(1, ID);
        ps.execute();
        ps.close();
        ps = dbc.getConnection().prepareStatement("Delete from Author where ID_Author=?");
        ps.setInt(1, ID);
        ps.execute();
        ps.close();
    }
}
