/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DataBase;

import Objects.CBook;
import java.sql.CallableStatement;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author vasena
 */
public class DBBook {

    DBConnection dbc;
    DBAuthor dba;

    public DBBook(DBConnection dbc) {
        this.dbc = dbc;
        this.dba = new DBAuthor(dbc);
    }

    public List LoadList() throws SQLException {
        if (!dbc.Active()) {
            return null;
        }
        List<CBook> BookList = new LinkedList<CBook>();
        String query = "Select * from Book";
        ResultSet rs = dbc.getStatement().executeQuery(query);
        while (rs.next()) {
            int ID = rs.getInt("ID_BOOK");
            int ID_Author = rs.getInt("ID_AUTHOR");
            String Title = rs.getString("TITLE");
            String Publisher = rs.getString("PUBLISHER");
            int Pages = rs.getInt("PAGES");
            int Year = rs.getInt("YEAR");
            CBook Book = new CBook(ID, ID_Author, Title, Publisher, Pages, Year);
            BookList.add(Book);
        }
        rs.close();
        for (CBook Book : BookList) {
            Book.setAUTHOR(dba.getAuthor(Book.getID_AUTHOR()));
        }
        return BookList;
    }

    public CBook getBook(int ID, List<CBook> BookList){
        CBook Result = null;
        for (CBook Book : BookList) {
            if (Book.getID() == ID) {
                Result = Book;
                break;
            }
        }
        return Result;
    }

     public List searchBook(String Title, String Publisher, String Pages,
             String Year, String ID_Catalog, String ID_Author) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        List<CBook> BookList = new LinkedList<CBook>();
        String query = "Select * from Book where ";
        if (Title!=null){
          query+="Title='"+Title+"'";
        }
        if (Title!=null && (Publisher!=null || Pages!=null || Year !=null || ID_Author!=null)){
          query+=" and ";
        }
        if (Publisher!=null){
          query+="Publisher='"+Publisher+"'";
        }
        if (Publisher!=null && (Pages!=null || Year !=null || ID_Author!=null)){
          query+=" and ";
        }
        if (Pages!=null){
          query+="Pages"+Pages;
        }
         if (Pages!=null && (Year !=null || ID_Author!=null)){
          query+=" and ";
        }
        if (Year!=null){
          query+="Year"+Year;
        }
        if (Year!=null && ID_Author!=null){
          query+=" and ";
        }
        if (ID_Author!=null){
          query+="ID_Author="+ID_Author;
        }
        if (Title!=null || Publisher!=null || Pages!=null || Year !=null || ID_Author!=null){
          query+=" and ";
        }
        query+="ID_Book in (Select ID_Book from Book_Catalog where ID_Catalog="+ID_Catalog+")";
        ResultSet rs = dbc.getStatement().executeQuery(query);
        while (rs.next()) {
           int ID = rs.getInt("ID_BOOK");
            int iID_Author = rs.getInt("ID_AUTHOR");
            Title = rs.getString("TITLE");
            Publisher = rs.getString("PUBLISHER");
            int iPages = rs.getInt("PAGES");
            int iYear = rs.getInt("YEAR");
            CBook Book = new CBook(ID, iID_Author, Title, Publisher, iPages, iYear);
            BookList.add(Book);
        }
        rs.close();
        for (CBook Book : BookList) {
            Book.setAUTHOR(dba.getAuthor(Book.getID_AUTHOR()));
        }
        return BookList;
    }

    public void addBook(int ID_Author, String Title, String Publisher, int Pages, int Year) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        CallableStatement cs= dbc.getConnection().prepareCall("{call add_book(?,?,?,?,?)}");
        cs.setInt(1, ID_Author);
        cs.setString(2, Title);
        cs.setString(3, Publisher);
        cs.setInt(4, Pages);
        cs.setInt(5, Year);
        cs.execute();
        cs.close();
    }

    public void updateBook(int ID, int ID_Author, String Title, String Publisher, int Pages, int Year) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        PreparedStatement ps = dbc.getConnection().prepareStatement("Update Book set ID_Author=?, Title=?, Publisher=?, Pages=?, Year=? where ID_Book=?");
        ps.setInt(1, ID_Author);
        ps.setString(2, Title);
        ps.setString(3, Publisher);
        ps.setInt(4, Pages);
        ps.setInt(5, Year);
        ps.setInt(6, ID);
        ps.execute();
        ps.close();
    }

    public void deleteBook(int ID) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        PreparedStatement ps = dbc.getConnection().prepareStatement("Delete from Book_Properties where ID_Book=?");
        ps.setInt(1, ID);
        ps.execute();
        ps.close();
        ps = dbc.getConnection().prepareStatement("Delete from Book_Catalog where ID_Book=?");
        ps.setInt(1, ID);
        ps.execute();
        ps.close();
        ps = dbc.getConnection().prepareStatement("Delete from Book where ID_Book=?");
        ps.setInt(1, ID);
        ps.execute();
        ps.close();
    }
}
