/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DataBase;

import Objects.CBook;
import Objects.CCatalog;
import java.sql.CallableStatement;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author Vasena
 */
public class DBCatalog {

    DBConnection dbc;
    DBBook dbb;

    public DBCatalog(DBConnection dbc) {
        this.dbc = dbc;
        this.dbb = new DBBook(dbc);
    }

    public List LoadList() throws SQLException {
        if (!dbc.Active()) {
            return null;
        }
        List<CCatalog> CatalogList = new LinkedList<CCatalog>();
        String query = "Select * from Catalog";
        ResultSet rs = dbc.getStatement().executeQuery(query);
        while (rs.next()) {
            int ID = rs.getInt("ID_CATALOG");
            int ID_Parent = rs.getInt("PARENT_ID_CATALOG");
            String Title = rs.getString("TITLE");
            CCatalog Catalog = new CCatalog(ID, ID_Parent, Title);
            CatalogList.add(Catalog);
        }
        rs.close();
        for (CCatalog Catalog : CatalogList) {
            Catalog.setPARENT(getCatalog(Catalog.getID_PARENT(), CatalogList));
        }
        return CatalogList;
    }

    public CCatalog getCatalog(int ID, List<CCatalog> CatalogList) {
        CCatalog Result = null;
        for (CCatalog Catalog : CatalogList) {
            if (Catalog.getID() == ID) {
                Result = Catalog;
                break;
            }
        }
        return Result;
    }

    public List getBookList(int ID) throws SQLException {
        if (!dbc.Active()) {
            return null;
        }
        List<CBook> AllBookList = dbb.LoadList();
        List<CBook> BookList = new LinkedList<CBook>();
        String query = "Select * from Book_Catalog where ID_Catalog=" + String.valueOf(ID);
        ResultSet rs = dbc.getStatement().executeQuery(query);
        while (rs.next()) {
            int ID_Book = rs.getInt("ID_BOOK");
            CBook Book = dbb.getBook(ID_Book, AllBookList);
            BookList.add(Book);
        }
        rs.close();
        return BookList;
    }

    public List getBookList(int ID, int ID_Parent) throws SQLException {
        if (!dbc.Active()) {
            return null;
        }
        List<CBook> AllBookList = dbb.LoadList();
        List<CBook> BookList = new LinkedList<CBook>();
        String query = "Select * from Book_Catalog where (ID_Catalog=" + String.valueOf(ID_Parent) + ")and(not(ID_Book in("
                + "Select ID_Book from Book_Catalog where ID_Catalog=" + String.valueOf(ID) + ")))";
        ResultSet rs = dbc.getStatement().executeQuery(query);
        while (rs.next()) {
            int ID_Book = rs.getInt("ID_BOOK");
            CBook Book = dbb.getBook(ID_Book, AllBookList);
            BookList.add(Book);
        }
        rs.close();
        return BookList;
    }

    public void addCatalog(int ID_Parent, String Title) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        PreparedStatement ps = dbc.getConnection().prepareStatement("Insert into Catalog values(catalog_.nextval,?,?)");
        ps.setInt(1, ID_Parent);
        ps.setString(2, Title);
        ps.execute();
        ps.close();
    }

    public void addBook(int ID_Book, int ID_Catalog) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        PreparedStatement ps = dbc.getConnection().prepareStatement("Insert into Book_Catalog values(b_catalog_.nextval,?,?)");
        ps.setInt(1, ID_Book);
        ps.setInt(2, ID_Catalog);
        ps.execute();
        ps.close();
    }

    public void addBook(int ID_Book) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        PreparedStatement ps = dbc.getConnection().prepareStatement("Insert into Book_Catalog values(b_catalog_.nextval,?,catalog_.currval)");
        ps.setInt(1, ID_Book);
        ps.execute();
        ps.close();
    }

    public void removeBook(int ID_Book, int ID_Catalog) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        CallableStatement cs = dbc.getConnection().prepareCall("{call delete_book_from_catalog(?,?)}");
        cs.setInt(1, ID_Book);
        cs.setInt(2, ID_Catalog);
        cs.execute();
        cs.close();
    }

    public void deleteCatalog(int ID_Catalog) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        CallableStatement cs = dbc.getConnection().prepareCall("{call delete_catalog(?)}");
        cs.setInt(1, ID_Catalog);
        cs.execute();
        cs.close();
    }
}
