/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DataBase;

import Objects.CProperty;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author Vasena
 */
public class DBProperty {

    DBConnection dbc;

    public DBProperty(DBConnection dbc) {
        this.dbc = dbc;
    }

    public List LoadList() throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        List<CProperty> PropertyList = new LinkedList<CProperty>();
        String query = "Select * from Property";
        ResultSet rs = dbc.getStatement().executeQuery(query);
        CProperty Property;
        while (rs.next()) {
            int ID = rs.getInt("ID_PROPERTY");
            String Title = rs.getString("TITLE");
            Property = new CProperty(ID, Title);
            PropertyList.add(Property);
        }
        rs.close();
        return PropertyList;
    }

    public List LoadBookList(int ID_Book) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        List<CProperty> PropertyList = new LinkedList<CProperty>();
        String query =
                "Select Book_Properties.ID_Book_Properties,Property.Title, Book_Properties.Value "
                + "from Book_Properties, Property "
                + "where (Book_Properties.ID_Book=" + String.valueOf(ID_Book)
                + ")and(Book_Properties.ID_Property=Property.ID_Property)";
        ResultSet rs = dbc.getStatement().executeQuery(query);
        CProperty Property;
        while (rs.next()) {
            int ID = rs.getInt("ID_BOOK_PROPERTIES");
            String Title = rs.getString("TITLE");
            String Value = rs.getString("VALUE");
            Property = new CProperty(ID, Title, Value);
            PropertyList.add(Property);
        }
        rs.close();
        return PropertyList;
    }

    public List LoadAList(int ID_Book) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        List<CProperty> PropertyList = new LinkedList<CProperty>();
        String query =
                "Select * from Property where (not(ID_Property in( "
                + "select ID_Property from Book_Properties "
                + "where (ID_Book=" + String.valueOf(ID_Book) + "))))";
        ResultSet rs = dbc.getStatement().executeQuery(query);
        CProperty Property;
        while (rs.next()) {
            int ID = rs.getInt("ID_PROPERTY");
            String Title = rs.getString("TITLE");
            Property = new CProperty(ID, Title);
            PropertyList.add(Property);
        }
        rs.close();
        return PropertyList;
    }

    public void addProperty(String Title) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        PreparedStatement ps = dbc.getConnection().prepareStatement("Insert into Property values(property_.nextval,?)");
        ps.setString(1, Title);
        ps.execute();
        ps.close();
    }

    public void addProperty(int ID_Property, int ID_Book, String Value) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        PreparedStatement ps = dbc.getConnection().prepareStatement("Insert into Book_Properties values(b_properties_.nextval,?,?,?)");
        ps.setInt(1, ID_Book);
        ps.setInt(2, ID_Property);
        ps.setString(3, Value);
        ps.execute();
        ps.close();
    }

    public void updateProperty(int ID_Property, String Title) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        PreparedStatement ps = dbc.getConnection().prepareStatement("Update Property set Title=? where ID_Property=?");
        ps.setString(1, Title);
        ps.setInt(2, ID_Property);
        ps.execute();
        ps.close();
    }
    public void updateValue(int ID, String Value) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        PreparedStatement ps = dbc.getConnection().prepareStatement("Update Book_Properties set Value=? where ID_Book_Properties=?");
        ps.setString(1, Value);
        ps.setInt(2, ID);
        ps.execute();
        ps.close();
    }

    public void deleteProperty(int ID_Property) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        PreparedStatement ps = dbc.getConnection().prepareStatement("Delete from Property where ID_Property=?");
        ps.setInt(1, ID_Property);
        ps.execute();
        ps.close();
    }

     public void deleteBookProperty(int ID) throws SQLException {
        if (!dbc.Active()) {
            throw new SQLException();
        }
        PreparedStatement ps = dbc.getConnection().prepareStatement("Delete from Book_Properties where ID_Book_Properties=?");
        ps.setInt(1, ID);
        ps.execute();
        ps.close();
    }
}
